#!/usr/local/bin/perl -w

%do = qw(BaEV 1 Harlequin 1 HERV15 1 HERV17 1 HERV3 1 HERV30 1 HERV70 1 HERV9 1 HERVE 1 HERVFH19 1 HERVFH21 1 HERVH 1 HERVH48 1 HERVI 1 HERVIP10F 1 HERVIP10FH 1 HERVK 1 HERVK11 1 HERVK11D 1 HERVK13 1 HERVK14 1 HERVK14C 1 HERVK22 1 HERVK3 1 HERVK9 1 HERVKC4 1 HERVL 1 HERVL18 1 HERVL66 1 HERVP71A 1 HERVR 1 HERVS71 1 HUERS-P1 1 HUERS-P2 1 HUERS-P3 1 LOR1 1 LOR1a 1 LOR1b 1 LTR1 1 LTR10 1 LTR10A 1 LTR10C 1 LTR10D 1 LTR10E 1 LTR10F 1 LTR12 1 LTR12B 1 LTR12C 1 LTR13 1 LTR13A 1 LTR14 1 LTR14A 1 LTR14B 1 LTR14C 1 LTR15 1 LTR17 1 LTR18 1 LTR18A 1 LTR18B 1 LTR19 1 LTR19A 1 LTR19B 1 LTR1B 1 LTR1C 1 LTR2 1 LTR21 1 LTR21A 1 LTR21B 1 LTR22 1 LTR22A 1 LTR22B 1 LTR23 1 LTR24 1 LTR24C 1 LTR26 1 LTR26B 1 LTR29 1 LTR2B 1 LTR2C 1 LTR3 1 LTR3 1 LTR32 1 LTR36 1 LTR38B 1 LTR38C 1 LTR39 1 LTR3A 1 LTR3B 1 LTR3B1 1 LTR4 1 LTR43 1 LTR44 1 LTR45 1 LTR45B 1 LTR45C 1 LTR46 1 LTR47A 1 LTR49 1 LTR5 1 LTR5_Hs 1 LTR51 1 LTR54 1 LTR57 1 LTR59 1 LTR5B 1 LTR6 1 LTR61 1 LTR62 1 LTR64 1 LTR64a 1 LTR66 1 LTR6A 1 LTR6B 1 LTR7 1 LTR70 1 LTR71 1 LTR71A 1 LTR71B 1 LTR72 1 LTR72B 1 LTR76 1 LTR77 1 LTR7A 1 LTR7B 1 LTR8 1 LTR8A 1 LTR9B 1 MER11 1 MER11A 1 MER11B 1 MER11C 1 MER11D 1 MER39B 1 MER4 1 MER41 1 MER41A 1 MER41B 1 MER41C 1 MER41D 1 MER41E 1 MER48 1 MER49 1 MER4A 1 MER4A1 1 MER4B 1 MER4C 1 MER4D 1 MER4E 1 MER4E1 1 MER50 1 MER50B 1 MER51 1 MER51A 1 MER51B 1 MER51C 1 MER51D 1 MER51E 1 MER52C 1 MER57 1 MER57A 1 MER57B 1 MER61 1 MER61A 1 MER61B 1 MER61C 1 MER61D 1 MER61E 1 MER65A 1 MER72 1 MER83 1 MER83B 1 MER83C 1 MER84 1 MER9 1 MLT2A 1 MLT2A1 1 MLT2A2 1 PABL_A 1 PRIMA4 1 PRIMA4_LTR 1 PRIMA41 1 PRIMAX 1 pTR5 1   Charlie3 1 HSMAR1 1 HSMAR2 1 HsTc2 1 MADE1 1 MER107 1 MER1 1 MER1A 1 MER1B 1 MER2 1 MER30 1 MER30B 1 MER44 1 MER44A 1 MER44B 1 MER44C 1 MER44D 1 MER47 1 MER47A 1 MER47B 1 MER6 1 MER6A 1 MER75 1 MER75B 1 MER85 1 PMER1 1 Ricksha 1 SVA 1 Tigger1 1 Tigger2 1 Tigger2a 1 Tigger3 1 Tigger3a 1 Tigger3b 1 Tigger3c 1 Tigger4 1 Tigger4a 1 Tigger4b 1 Tigger5 1 Tigger7 1);

foreach $file (@ARGV) {
    open (IN, $file);
    ($outfile = $file) .= ".primspec";
    open (OUT, ">$outfile");
    while (<IN>) {
	@bit = split;
	next if !$bit[10] || $bit[10] eq 'Low_complexity' || $bit[10] eq 'Simple_repeat';
	if ($bit[10] =~ /^SINE/) { 
	    print OUT if $bit[10] eq 'SINE/Alu';
	} elsif ($bit[10] =~ /^LINE/) {
	    if ($bit[10] eq 'LINE/L1') {
		print OUT if $bit[9] =~ /^L1P|^L1MA[1-5]$|^L1HS|L1M1/;
		print OUT if $bit[9] eq 'L1' && $bit[1] <= 16;
	    }
	} elsif ($bit[10] =~ /^LTR/) {
	    if ($bit[10] eq 'LTR/MaLR') {
		print OUT if $bit[9] =~ /^THE|^MST/; # got really lucky with my nomenclature there (no, I just knew it)
	    } else {
		$bit[9] =~ s/-int//;
		print OUT if $do{$bit[9]};
	    }
	} elsif ($do{$bit[9]} || $bit[10] =~ /^Satellite/) {
	    print OUT; 
	} elsif ($bit[10] =~ /RNA/ && $bit[1] < 15) {
            print OUT;   
        }
    }
}


